unit BC_IniIO;

interface

uses
 IniFiles , Forms , SysUtils , Graphics , Classes;

 procedure LoadIni    (IniPath  : String);
 procedure SaveIni    (IniPath  : String);
 procedure LoadNewPage();

implementation

uses
  BC_Main;

//------------------------------------------------------------------------------
procedure LoadIni(IniPath : String);
 var
  IniFile                                           : TIniFile;
  FS_Bold , FS_Italic , FS_UnderLine , FS_StrikeOut : Boolean;
  TmpFont                                           : TFont;
begin
  IniFile := TIniFile.Create(IniPath);
  TmpFont := TFont.Create();
  try
  try
    FS_Bold      :=          IniFile.ReadBool   ('Font' , 'Bold'      , False);
    FS_Italic    :=          IniFile.ReadBool   ('Font' , 'Italic'    , False);
    FS_UnderLine :=          IniFile.ReadBool   ('Font' , 'UnderLine' , False);
    FS_StrikeOut :=          IniFile.ReadBool   ('Font' , 'StrikeOut' , False);
    with TmpFont do  // etHgݒBoolɂĂۑ
    begin
      Name  :=               IniFile.ReadString ('Font' , 'Name'      , 'Terminal');
      Size  :=               IniFile.ReadInteger('Font' , 'Size'      , 14);
      Color := StringToColor(IniFile.ReadString ('Font' , 'Color'     , 'clWindowText'));
      Style := [];
      if (FS_Bold)      then  Style := Style + [fsBold];
      if (FS_Italic)    then  Style := Style + [fsItalic];
      if (FS_UnderLine) then  Style := Style + [fsUnderLine];
      if (FS_StrikeOut) then  Style := Style + [fsStrikeOut];
    end;
    with Form_Main do
    begin
      Left                        := IniFile.ReadInteger('System' , 'Left '       , 0);
      Top                         := IniFile.ReadInteger('System' , 'Top'         , 0);
//    Width                       := IniFile.ReadInteger('System' , 'Width'       , 640);
//    Height                      := IniFile.ReadInteger('System' , 'Height'      , 480);
      SaveDialog.FileName         := IniFile.ReadString ('System' , 'Last Path'   , './');
      PageControl.ActivePageIndex := IniFile.ReadInteger('System' , 'Active Page' , 0);
      MItem_TaskTray.Checked      := IniFile.ReadBool   ('System' , 'Task-Tray'   , False);
      MItem_StayFront.Checked     := IniFile.ReadBool   ('System' , 'Stay Front'  , False);
      MItem_CloseCheck.Checked    := IniFile.ReadBool   ('System' , 'Close Check' , True);
      FColumnDivStr               := IniFile.ReadString ('System' , 'Column Div'  , #9);
     // ŗLn
      Edit_Name.Text              := IniFile.ReadString ('System' , 'Player Name' , 'Client A');
      Edit_Server.Text            := IniFile.ReadString ('System' , 'Server Host' , 'LocalHost');
      SpinEdit_Port.Value         := IniFile.ReadInteger('System' , 'Server Port' , 8799);
      RadioGroup_Play.ItemIndex   := IniFile.ReadInteger('System' , 'Play Style'  , 0);
      RadioGroup_Target.ItemIndex := IniFile.ReadInteger('System' , 'Send Target' , 0);
      if (IniFile.ReadBool('System' , 'Well Known Port' , False)) then SpinEdit_Port.MinValue := 0;
      SpinEdit_FtOrder.Value := IniFile.ReadInteger('Game' , 'Factory Order'    , 5);
      SpinEdit_W1Order.Value := IniFile.ReadInteger('Game' , 'Whole1  Order'    , 5);
      SpinEdit_W2Order.Value := IniFile.ReadInteger('Game' , 'Whole2  Order'    , 5);
      SpinEdit_RtOrder.Value := IniFile.ReadInteger('Game' , 'Retail  Order'    , 5);
      SpinEdit_FtShipM.Value := IniFile.ReadInteger('Game' , 'Factory Shipment' , 5);
      SpinEdit_W1ShipM.Value := IniFile.ReadInteger('Game' , 'Whole1  Shipment' , 5);
      SpinEdit_W2ShipM.Value := IniFile.ReadInteger('Game' , 'Whole2  Shipment' , 5);
      SpinEdit_RtShipM.Value := IniFile.ReadInteger('Game' , 'Retail  Shipment' , 5);
      if (ListView_History.Columns.Count > 8) then
      begin
        ListView_History.Column[0].Width := IniFile.ReadInteger('Column Width' , 'Turn'          , 50);
        ListView_History.Column[1].Width := IniFile.ReadInteger('Column Width' , 'Factory Stock' , 115);
        ListView_History.Column[2].Width := IniFile.ReadInteger('Column Width' , 'Whole1  Stock' , 130);
        ListView_History.Column[3].Width := IniFile.ReadInteger('Column Width' , 'Whole2  Stock' , 140);
        ListView_History.Column[4].Width := IniFile.ReadInteger('Column Width' , 'Retail  Stock' , 115);
        ListView_History.Column[5].Width := IniFile.ReadInteger('Column Width' , 'BackLog'       , 65);
        ListView_History.Column[6].Width := IniFile.ReadInteger('Column Width' , 'Demand'        , 65);
        ListView_History.Column[7].Width := IniFile.ReadInteger('Column Width' , 'Order'         , 55);
        ListView_History.Column[8].Width := IniFile.ReadInteger('Column Width' , 'Shipment'      , 100);
      end;
      Font.Assign(TmpFont);
    end;
  //LastDir := ExcludeTrailingBackSlash(StringReplace(IniFile.ReadString('System' , 'Last Directory' , '.') , '/' , '\' , [rfReplaceAll]));
  //Application.HintPause     := Round(IniFile.ReadFloat('System' , 'Before Hint' , 1) * 1000);
  //Application.HintHidePause := Round(IniFile.ReadFloat('System' , 'Hint Time'   , 5) * 1000);
  //LogoTime                  := Round(IniFile.ReadFloat('System' , 'Logo Time'   , 2) * 1000);
  finally
    TmpFont.Free();
    IniFile.Free();
  end
  except
    raise;
  end;
end;

//------------------------------------------------------------------------------
procedure SaveIni(IniPath : String);
 var
  IniFile : TIniFile;
  TmpFont : TFont;
begin
  IniFile := TIniFile.Create(IniPath);
  TmpFont := TFont.Create();
  try
  try
    with Form_Main do
    begin
      IniFile.WriteInteger('System' , 'Left'             , Left);
      IniFile.WriteInteger('System' , 'Top'              , Top);
      IniFile.WriteInteger('System' , 'Width'            , Width);
      IniFile.WriteInteger('System' , 'Height'           , Height);
//    IniFile.WriteBool   ('System' , 'Word Wrap'        , MItem_WordWrap.Checked);
      IniFile.WriteString ('System' , 'Last Path'        , SaveDialog.FileName);
      IniFile.WriteInteger('System' , 'Active Page'      , PageControl.ActivePageIndex);
//    IniFile.WriteBool   ('System' , 'Want Tabs'        , MItem_Tabs.Checked);
      IniFile.WriteBool   ('System' , 'Task-Tray'        , MItem_TaskTray.Checked);
      IniFile.WriteBool   ('System' , 'Stay Front'       , MItem_StayFront.Checked);
      IniFile.WriteBool   ('System' , 'Close Check'      , MItem_CloseCheck.Checked);
     // ŗLn
      IniFile.WriteString ('System' , 'Player Name'      , Edit_Name.Text);
      IniFile.WriteString ('System' , 'Server Host'      , Edit_Server.Text);
      IniFile.WriteInteger('System' , 'Server Port'      , SpinEdit_Port.Value);
      IniFile.WriteInteger('System' , 'Play Style'       , RadioGroup_Play.ItemIndex);
      IniFile.WriteInteger('System' , 'Send Target'      , RadioGroup_Target.ItemIndex);
      IniFile.WriteInteger('Game'   , 'Factory Order'    , SpinEdit_FtOrder.Value);
      IniFile.WriteInteger('Game'   , 'Whole1  Order'    , SpinEdit_W1Order.Value);
      IniFile.WriteInteger('Game'   , 'Whole2  Order'    , SpinEdit_W2Order.Value);
      IniFile.WriteInteger('Game'   , 'Retail  Order'    , SpinEdit_RtOrder.Value);
      IniFile.WriteInteger('Game'   , 'Factory Shipment' , SpinEdit_FtShipM.Value);
      IniFile.WriteInteger('Game'   , 'Whole1  Shipment' , SpinEdit_W1ShipM.Value);
      IniFile.WriteInteger('Game'   , 'Whole2  Shipment' , SpinEdit_W2ShipM.Value);
      IniFile.WriteInteger('Game'   , 'Retail  Shipment' , SpinEdit_RtShipM.Value);
      if (ListView_History.Columns.Count > 8) then
      begin
        IniFile.WriteInteger('Column Width' , 'Turn'          , ListView_History.Column[0].Width);
        IniFile.WriteInteger('Column Width' , 'Factory Stock' , ListView_History.Column[1].Width);
        IniFile.WriteInteger('Column Width' , 'Whole1 Stock'  , ListView_History.Column[2].Width);
        IniFile.WriteInteger('Column Width' , 'Whole2 Stock'  , ListView_History.Column[3].Width);
        IniFile.WriteInteger('Column Width' , 'Retail Stock'  , ListView_History.Column[4].Width);
        IniFile.WriteInteger('Column Width' , 'BackLog'       , ListView_History.Column[5].Width);
        IniFile.WriteInteger('Column Width' , 'Demand'        , ListView_History.Column[6].Width);
        IniFile.WriteInteger('Column Width' , 'Order'         , ListView_History.Column[7].Width);
        IniFile.WriteInteger('Column Width' , 'Shipment'      , ListView_History.Column[8].Width);
      end;
      TmpFont.Assign(Font);
    end;
    IniFile.WriteString ('Font' , 'Name'      , TmpFont.Name);
    IniFile.WriteInteger('Font' , 'Size'      , TmpFont.Size);
    IniFile.WriteString ('Font' , 'Color'     , ColorToString(TmpFont.Color));
    IniFile.WriteBool   ('Font' , 'Bold'      , (fsBold      in TmpFont.Style));
    IniFile.WriteBool   ('Font' , 'Italic'    , (fsItalic    in TmpFont.Style));
    IniFile.WriteBool   ('Font' , 'UnderLine' , (fsUnderLine in TmpFont.Style));
    IniFile.WriteBool   ('Font' , 'StrikeOut' , (fsStrikeOut in TmpFont.Style));
  finally
    TmpFont.Free();
    IniFile.Free();
  end
  except
    raise;
  end;
end;


//------------------------------------------------------------------------------
//------------------ R}hCt@CI[v --------------------
procedure LoadNewPage();
 var
  i       : Integer;
  TmpList : TStringList;
begin
  TmpList := TStringList.Create();
  try
  try
    for i := 1 to ParamCount() do
    begin
      TmpList.Add(StringReplace(ParamStr(i) , '"' , '' , [rfReplaceAll]));
    end;
    if (TmpList.Count < 1) then Exit;
    for i := 0 to TmpList.Count - 1 do
    begin
      if (not FileExists(TmpList.Strings[i]))    then Continue;
//    if (not AskOpenBinary(TmpList.Strings[i])) then Continue; // oCi`FbN
    end;
  finally
    TmpList.Free();
  end
  except
    raise;
  end;
end;

//------------------------------------------------------------------------------
end.
